import subprocess, sys, os, shutil, glob

DS = "//"

chap     = str(sys.argv[1])
kind     = str(sys.argv[2]).upper()
rootbase = open("rootbase.tex","r")
root     = open("root.tex", "w")

if chap not in [ '00', '01', '02', '03', '04', '05', '06', '07', '08', '09']:
    print "Invalid chapter"
    os._exit(0)

if kind in ['S']:
    root.write("\\documentclass[xcolor=dvipsnames]{beamer}\n")
elif kind in ['H','X']:
    root.write("\\documentclass[handout,xcolor=dvipsnames]{beamer}\n")
else:
    print "Expected specification of slides (S) or handouts (H)"
    os._exit(0)

for line in rootbase:
    if line.startswith("%@@CHAP"):
        line = "\\renewcommand{\chap}{"+chap+"}\n"
    if line.startswith("%@@NOTES") and kind in ['X']:
        line = "\\renewcommand{\NotesFrame}{}\n"
    root.write(line)
root.close()

command = ["pdflatex", "-halt-on-error", "root.tex"]
if not subprocess.call(command):
    subprocess.call(command)
else:
    print "Error occurred, bailing out..."
    os._exit(0)

if kind == 'S':
    outfilename = "slides."+chap+".pdf"
    shutil.move("root.pdf","pdfslides"+DS+outfilename)
else:
    if kind == 'H':
        outfilename = "notes."+chap+".pdf"
    else:
        outfilename = "handout."+chap+".pdf"
    command = ["pdfnup", "--nup", "2x3", "--delta", "\"0cm 2cm\"", "--scale", "0.91", "--outfile", outfilename, "root.pdf"]
    subprocess.call(command)
    shutil.move(outfilename,"pdfslides"+DS+outfilename)

for f in glob.glob("root.*"):
    os.remove(f)
